/* 
 * $RCSfile: msg_s.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: msg_s.h,v $
 * Revision 1.13  1994/04/12  22:39:09  hkaram
 * Removed references to MSG_NEW_ALG
 *
 * Revision 1.12  1993/12/14  18:23:35  menze
 *   [ 1993/12/11          menze ]
 *   fixed #endif comments
 *
 */

/*
 * Independent definition of the message structure.  Protocols should
 * include msg.h which includes this file.
 */

#ifndef msg_s_h
#define msg_s_h

typedef struct MNode MNode, MNodeLeaf, MNodePair, MNodePage, MNodeBuf;

/*
 * the Msg structure
 */

#ifndef xtype_h
#include "xtype.h"
#endif

typedef struct {
  char	     *headPtr;
  char	     *tailPtr;
  char	     *stackHeadPtr;
  char	     *stackTailPtr;
  struct {
    unsigned short numNodes;
    unsigned int   myStack;
  } state;
  MNodeLeaf* stack;
  MNode*     tree;
  VOID       *attr;
  MNodeLeaf  *lastStack;
  char	     *lastStackTailPtr;
  struct {
    unsigned int   myLastStack;
  } tailstate;
  int	attrLen;
} Msg;

#endif /* msg_s_h */
