/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: scout_device.h,v $
 *
 * HISTORY
 * $Log: scout_device.h,v $
 * Revision 1.4  1994/06/11  00:03:01  menze
 * Added copyright notice
 *
 * Revision 1.3  1994/06/08  22:55:42  druschel
 * Added a handler argument to scout_device_set_interrupt()
 *
 * Revision 1.2  1994/05/15  00:05:56  davidm
 * (scout_device_set_interrupt): added.
 *
 * Revision 1.1  1994/04/22  02:09:49  davidm
 * Initial revision
 *
 */
/*
 * Device interface.
 */
#ifndef scout_device_h
#define scout_device_h

#include "scout.h"
#include "scout_sync_arch.h"

#define SCOUT_MAX_DEVICE_NAME_LEN	16

typedef struct scout_device_info {
    struct scout_device_info *next;
    char	*name;		/* adaptor name */
    void	*base_addr;	/* virtual address of adaptor */
    Scout_IPL	ipl;		/* interrupt priority level of device */
    u_long	rom_offset;	/* offset to (optional) rom */
} Scout_Device_Info;

extern void scout_device_add (Scout_Device_Info *device_info);
extern const Scout_Device_Info *scout_device_info (char *device_name);
extern void scout_device_set_interrupt (const Scout_Device_Info *device_info,
					int on, void (*handler)(void*), 
					void *interrupt_arg);

#endif /* scout_device_h */
